---
title: "FreeBSD 7.2-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008, 2009 The FreeBSD Documentation Project</p>

<p class="PUBDATE">$FreeBSD: releng/7.2/release/doc/en_US.ISO8859-1/relnotes/article.sgml
191705 2009-04-30 21:20:09Z hrs $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Microsoft, IntelliMouse, MS-DOS, Outlook, Windows, Windows Media and Windows NT are
either registered trademarks or trademarks of Microsoft Corporation in the United States
and/or other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN28" name="AEN28"></a>
<p>The release notes for FreeBSD 7.2-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 7.2-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 7.2-RELEASE. It describes
recently added, changed, or deleted features of FreeBSD. It also provides some notes on
upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 7.2-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a href="../../../../doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="../../../../doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 7.2-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
7.1-RELEASE.</p>

<p>Typical release note items document recent security advisories issued after
7.1-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>Problems described in the following security advisories have been fixed. For more
information, consult the individual advisories available from <a
href="http://security.FreeBSD.org/" target="_top">http://security.FreeBSD.org/</a>.</p>

<div class="INFORMALTABLE"><a id="AEN48" name="AEN48"></a>
<table border="0" frame="void" class="CALSTABLE">
<!--
<col width="1*" />
<col width="1*" />
<col width="3*" />
-->
<thead>
<tr>
<th>Advisory</th>
<th>Date</th>
<th>Topic</th>
</tr>
</thead>

<tbody>
<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:01.lukemftpd.asc"
target="_top">SA-09:01.lukemftpd</a></td>
<td>07&nbsp;January&nbsp;2009</td>
<td>
<p>Cross-site request forgery in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lukemftpd&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lukemftpd</span>(8)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:02.openssl.asc"
target="_top">SA-09:02.openssl</a></td>
<td>07&nbsp;January&nbsp;2009</td>
<td>
<p>OpenSSL incorrectly checks for malformed signatures</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:03.ntpd.asc"
target="_top">SA-09:03.ntpd</a></td>
<td>13&nbsp;January&nbsp;2009</td>
<td>
<p>ntpd cryptographic signature bypass</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:04.bind.asc"
target="_top">SA-09:04.bind</a></td>
<td>13&nbsp;January&nbsp;2009</td>
<td>
<p>BIND DNSSEC incorrect checks for malformed signatures</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:05.telnetd.asc"
target="_top">SA-09:05.telnetd</a></td>
<td>16&nbsp;February&nbsp;2009</td>
<td>
<p>telnetd code execution vulnerability</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:06.ktimer.asc"
target="_top">SA-09:06.ktimer</a></td>
<td>23&nbsp;March&nbsp;2009</td>
<td>
<p>Local privilege escalation</p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:07.libc.asc"
target="_top">SA-09:07.libc</a></td>
<td>04&nbsp;April&nbsp;2009</td>
<td>
<p>Information leak in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=db&sektion=3&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">db</span>(3)</span></a></p>
</td>
</tr>

<tr>
<td><a href="http://security.freebsd.org/advisories/FreeBSD-SA-09:08.openssl.asc"
target="_top">SA-09:08.openssl</a></td>
<td>22&nbsp;April&nbsp;2009</td>
<td>
<p>Remotely exploitable crash in OpenSSL</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> kernel
debugger now supports a <tt class="COMMAND">show mount</tt> subcommand.</p>

<p>The FreeBSD DTrace subsystem now supports a probe for process execution.</p>

<p>[amd64] The FreeBSD kernel virtual address space has been increased to 6GB. This
allows subsystems to use larger virtual memory space than before. For example, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=zfs&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">zfs</span>(8)</span></a> adaptive
replacement cache (ARC) requires large kernel memory space to cache file system data, so
it benefits from the increased address space. Note that the ceiling on the kernel map
size is now 60% of the size rather than an absolute quantity.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>
subsystem has been updated. Changes include:</p>

<ul>
<li>
<p>Multiple addresses of both IPv4 and IPv6 per jail has been supported. It is even
possible to have jails without an IP address at all, which basically gives one a chrooted
environment with restricted process view and no networking.</p>
</li>

<li>
<p>SCTP (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sctp&sektion=4&manpath=FreeBSD+7.2-RELEASE"><span class="CITEREFENTRY"><span class="REFENTRYTITLE">sctp</span>(4)</span></a>) with
IPv6 in jails has been implemented.</p>
</li>

<li>
<p>Specific CPU binding by using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuset&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuset</span>(1)</span></a> has
been implemented. Note that the current implementation allows the superuser inside of the
jail to change the CPU bindings specified. This behavior will be fixed in the next
release.</p>
</li>

<li>
<p>A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> can
start with a specific route FIB now.</p>
</li>

<li>
<p>A <tt class="LITERAL">show jails</tt> subcommand in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(8)</span></a> has been
added.</p>
</li>

<li>
<p>Compatibility support which permits 32-bit jail binaries to be used on 64-bit systems
to manage jails has been added.</p>
</li>

<li>
<p>Note that both version numbers of <tt class="LITERAL">jail</tt> and <tt
class="LITERAL">prison</tt> in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> have
been updated for the new features.</p>
</li>
</ul>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kld&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kld</span>(4)</span></a> now
supports installing 32-bit system calls to the FreeBSD system call translation layer from
kernel modules.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ktr&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ktr</span>(4)</span></a> now
supports a new KTR tracepoint in the <tt class="LITERAL">KTR_CALLOUT</tt> class to note
when a callout routine finishes executing.</p>

<p>Types of variables used to track the amount of allocated System V shared memory have
been changed from <tt class="LITERAL">int</tt> to <tt class="LITERAL">size_t</tt>. This
makes it possible to use more than 2 GB of memory for shared memory segments on 64-bit
architectures. Please note the new BUGS section in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shmctl&sektion=2&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">shmctl</span>(2)</span></a> and
<tt class="FILENAME">/usr/src/UPDATING</tt> for limitations of this temporary
solution.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=3&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(3)</span></a> leaf
nodes have a flag to tag themselves as MPSAFE now.</p>

<p>The FreeBSD 32-bit system call translation layer now supports installing 32-bit system
calls for <tt class="LITERAL">VFS_AIO</tt>.</p>

<p>[amd64, i386] The FreeBSD virtual memory subsystem now supports fully transparent use
of <b class="APPLICATION">superpages</b> for application memory; application memory pages
are dynamically promoted to or demoted from superpages without any modification to
application code. This change offers the benefit of large page sizes such as improved
virtual memory efficiency and reduced TLB (translation lookaside buffer) misses without
downsides like application changes and virtual memory inflexibility. This is disabled by
default and can be enabled by setting a loader tunable <code
class="VARNAME">vm.pmap.pg_ps_enabled</code> to <tt class="LITERAL">1</tt>.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">boot</span>(8)</span></a> now
supports 4-byte volume ID that certain versions of <span
class="TRADEMARK">Windows</span>&reg; put into the MBR and invoking PXE by pressing F6
key on some supported BIOSes.</p>

<p>[i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=boot&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">boot</span>(8)</span></a> BTX
loader has been improved. This fixes several boot issues on recent machines reported for
7.1-RELEASE and before.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> is now
able to obtain DHCP options from network boot via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kenv&sektion=2&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kenv</span>(2)</span></a>
variables.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=loader&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">loader</span>(8)</span></a> has
been fixed. Now the following line works as expected:</p>

<pre class="PROGRAMLISTING">
loader_conf_files="<tt class="REPLACEABLE"><i>foo</i></tt> <tt
class="REPLACEABLE"><i>bar</i></tt> ${<tt class="REPLACEABLE"><i>variable</i></tt>}"
</pre>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>[sparc64] The FreeBSD now supports Ultra SPARC III (Cheetah) processor family.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi</span>(4)</span></a>
subsystem now supports a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(8)</span></a>
variable <code class="VARNAME">debug.batt.batt_sleep_ms</code>. On some laptops with
smart batteries, enabling battery monitoring software causes keystrokes from <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a> to be
lost. This sysctl variable adds a delay in millisecond to the status checking code as a
workaround.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_asus&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_asus</span>(4)</span></a>
driver now supports Asus A8Sr notebooks.</p>

<p>[powerpc] Support for the AltiVec, a floating point and integer SIMD instruction set
has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a>
driver, which provides a special device <tt class="FILENAME">/dev/cpuctl</tt> as an
interface to the system CPU has been added. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpuctl&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpuctl</span>(4)</span></a>
functionality includes the ability to retrieve CPUID information, read/write machine
specific registers (MSR), and perform CPU firmware updates.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
driver now supports an <code class="VARNAME">hw.est.msr_info</code> loader tunable. When
this is set to <tt class="LITERAL">1</tt>, it attempts to build a simple list containing
just the high and low frequencies if it cannot obtain a frequency list from either ACPI
or the static tables. This is disabled by default.</p>

<p>[amd64, i386] CPU frequency change notifiers are now disabled when the TSC is P-state
invariant. Also, a new loader tunable <code
class="VARNAME">kern.timecounter.invariant_tsc</code> has been added to force this
behavior by setting it to non-zero.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a> driver
now disables the interrupt handler which is called from the keyboard callback function
when polled mode is enabled. This fixes the problem of duplicated/missing characters at
the mountroot prompt on multi CPU systems while <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kbdmux&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kbdmux</span>(4)</span></a> is
enabled.</p>

<p>In the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pci&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pci</span>(4)</span></a> subsystem
INTx is now disabled when MSI/MSIX is enabled. This change fixes interrupt storm related
issues.</p>

<p>[sparc64] The schizo(4) driver for Schizo Fireplane/Safari to PCI 2.1 and Tomatillo
JBus to PCI 2.2 bridges has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=u3g&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">u3g</span>(4)</span></a> driver
for USB based 3G cards and dongles including Vodafone Mobile Connect Card 3G, Qualcomm
CDMA MSM, Huawei E220, Novatel U740, Sierra MC875U, and so on has been added. This
provides support for the multiple USB-to-serial interfaces exposed by many 3G USB/PC Card
modems, and the device is accessed through the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ucom&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ucom</span>(4)</span></a> driver
which makes it behave like a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tty&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tty</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>
scheduler now supports a loader tunable <code
class="VARNAME">machdep.hyperthreading_enabled</code> as the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_4bsd&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_4bsd</span>(4)</span></a>
does. Note that it cannot be modified at run-time.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=agp&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">agp</span>(4)</span></a> driver
now supports Intel G4X series graphics chipsets.</p>

<p>The DRM, a kernel module named Direct Rendering Manager that gives direct hardware
access to DRI clients, has been updated. Support for AMD/ATI r500, r600, r700, and IGP
based chips, XGI V3XE/V5/V8, and Intel i915 chipsets has been improved.</p>

<p>A new loader tunable <code class="VARNAME">hw.drm.msi</code> has been added to control
if DRM uses MSI or not. This is set to <tt class="LITERAL">1</tt> (enabled) by
default.</p>

<p>The snd_au88x0(4) driver for Aureal Vortex 1/2/Advantage PCI has been removed because
this was broken for a long time.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_hda&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_hda</span>(4)</span></a>
driver has been updated. This changes include support for multiple codec per HDA bus,
multiple functional groups per codec, multiple audio devices per functional group,
digital (SPDIF/HDMI) audio input/output, suspend/resume, and part of multichannel
audio.</p>

<p>Note that due to added HDMI audio and logical audio devices support, the updated
driver often provides several PCM devices. This means that in some cases the system
default audio device no longer corresponds to the users's habitual audio connectors. In
such cases the default device can be specified in audio applications' setup or defined
globally via <code class="VARNAME">hw.snd.default_unit sysctl</code>, as described in the
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sound&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sound</span>(4)</span></a> manual
page.</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ae&sektion=4&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ae</span>(4)</span></a> driver now
supports WoL (Wake on LAN).</p>

<p>[amd64, i386] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ale&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ale</span>(4)</span></a> driver is
now included in the <tt class="FILENAME">GENERIC</tt> kernel.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath_hal&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath_hal</span>(4)</span></a>,
Atheros Hardware Access Layer, has been updated to the open source version.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=axe&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">axe</span>(4)</span></a> driver
has been improved in performance by eliminating extra context switches and now supports
Apple USB Ethernet adapter.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bce&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bce</span>(4)</span></a> driver's
firmware has been updated to the latest version (4.6.X).</p>

<p>The ciphy(4) driver now supports Vitesse VSC8211 PHY.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cxgb&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cxgb</span>(4)</span></a> driver
has been updated to firmware revision 4.7 and now supports hardware MAC statistics.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver
has been improved. Changes include:</p>

<ul>
<li>
<p>The checksum offload feature can be controlled by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
now.</p>
</li>

<li>
<p>Rx checksum offload support for 82559 or later controllers has been added.</p>
</li>

<li>
<p>TSO (TCP Segmentation Offload) support for 82550 and 82551 controllers has been
added.</p>
</li>

<li>
<p>WoL (Wake on LAN) support for 82550, 82551, 82558, and 82559-based controllers has
been added. Note that ICH based controllers are treated as 82559, and 82557, earlier
revisions of 82558, and 82559ER have no WoL capability.</p>
</li>

<li>
<p>VLAN hardware tag insertion/stripping support and Tx/Rx checksum offload for VLAN
frames support have been added. Note that the VLAN hardware assistance is available only
on 82550 or 82551-based controllers.</p>
</li>
</ul>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=igb&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">igb</span>(4)</span></a> driver,
which prevents the loader tunable <code class="VARNAME">hw.igb.ave_latency</code> from
working, has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgbe&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ixgbe</span>(4)</span></a> driver
has been updated to version 1.7.4.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jme&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jme</span>(4)</span></a> driver
now supports newer JMicron JMC250/JMC260 revisions.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=msk&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">msk</span>(4)</span></a> driver
has been improved. An issue which makes it hang up in a certain condition has been fixed.
Hardware MAC statistics support has been added and users can get the information via
sysctl variables named <code class="VARNAME">dev.msk.<tt
class="REPLACEABLE"><i>N</i></tt>.stats</code>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mxge&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mxge</span>(4)</span></a> driver
now supports some newer revisions and 10GBASE-LRM and 10GBASE-Twinax media types.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nfe&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nfe</span>(4)</span></a> driver
now supports hardware MAC statistics.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver has been
improved. It now detects the link status. A new loader tunable <code
class="VARNAME">hw.re.prefer_iomap</code> has been added, to disable memory register
mapping. This tunable is <tt class="LITERAL">0</tt> for all controllers except RTL8169SC
family.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rl&sektion=4&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rl</span>(4)</span></a> driver has been
improved. It now detects the link status and a bug which prevents it from working on
systems with more than 4GB memory has been fixed.</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a> on VLAN
tagged frame handling has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=txp&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">txp</span>(4)</span></a> driver
now works on all supported architectures. Support has been added for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>, WoL,
checksum offload when VLAN enabled, and link state change handling has been improved, and
new sysctl variables <code class="VARNAME">dev.txp.<tt
class="REPLACEABLE"><i>N</i></tt>.stats</code> for MAC statistics have been added. New
sysctl variables <code class="VARNAME">dev.txp.<tt
class="REPLACEABLE"><i>N</i></tt>.process_limit</code> has been added, to control how
many received frames should be served in Rx handler (set to 64 by default and valid
ranges are 16 to 128 in unit of frames). The firmware has been updated to the latest
version.</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>IPv4 source address selection for unbound sockets has been implemented as follows:</p>

<ol type="1">
<li>
<p>If we found a route, use the address corresponding to the outgoing interface.</p>
</li>

<li>
<p>Otherwise we assume the foreign address is reachable on a directly connected network
and try to find a corresponding interface to take the source address from.</p>
</li>

<li>
<p>As a last resort use the default jail address.</p>
</li>
</ol>

<p>This also changes the semantics of selecting the IP for processes within a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> as it
now uses the same logic as outside the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a>.</p>

<p>The TCP MD5 Signature Option (RFC 2385) for IPv6 has been implemented in the same way
it has been implemented for IPv4.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_netflow</span>(4)</span></a>
Netgraph node now includes support for generating egress netflow instead or in addition
to ingress. An <tt class="LITERAL">NGM_NETFLOW_SETCONFIG</tt> control message has been
added to control the new functionality.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> Ethernet
tunnel software network interface now supports a new <tt class="LITERAL">TAPGIFNAME</tt>
character device ioctl. This is a convenient shortcut to obtain the network interface
name using a file descriptor to a character device.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> now
supports <tt class="LITERAL">SIOCSIFMTU</tt> ioctl to set a higher MTU than 1500
(ETHERMTU). This allows <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> devices
to be added to the same bridge (which requires all interface members to have the same
MTU) with an interface configured for jumbo frames.</p>

<p>The domains list for handling the list of supported domains in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unix&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unix</span>(4)</span></a> (UNIX
domain protocol family) subsystem is now MPSAFE.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now supports Marvell PATA M88SX6121.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
now recognizes nForce MCP67 and MCP73 SATA controllers as AHCI.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>
driver now includes preliminary support for DDF metadata found on Adaptec HostRAID
controllers. Note that spares and rebuilds are not supported yet.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cam&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cam</span>(4)</span></a> SCSI
subsystem now supports a new sysctl variable <code
class="VARNAME">kern.cam.cd.retry_count</code>. This controls the number of retries for
the CD media. When trying to read scratched or damaged CDs and DVDs, the default
mechanism is sub-optimal, and programs like <b class="APPLICATION">ddrescue</b> do much
better if you turn off the retries entirely since their algorithms do it by themselves.
This value is set to <tt class="LITERAL">4</tt> (for a total of 5 attempts) by default.
Setting it to <tt class="LITERAL">0</tt> turns off all retry attempts.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ciss&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ciss</span>(4)</span></a> driver
which caused low &#8220;max device openings&#8221; count and led to poor performance has
been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glabel&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glabel</span>(8)</span></a> GEOM
class now supports a new UFS-based label called <tt class="LITERAL">ufsid</tt> that can
be used to reference UFS-carrying devices by the unique file system ID. This file system
ID is automatically generated and detected when the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=glabel&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">glabel</span>(8)</span></a> GEOM
class is enabled. An example of this new label is: <tt
class="FILENAME">/dev/ufsid/48e69c8b5c8e1b43</tt>. The benefit of using GEOM labels in
general is to avoid problems of device renaming when shifting drives or controllers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gjournal&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gjournal</span>(8)</span></a> GEOM
class now supports the root file system. Previously, an unclean shutdown would make it
impossible to mount the root file system at boot.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpart&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpart</span>(8)</span></a> utility
has been updated. The APM scheme now supports Tivo Series 1 partitions (read only), a new
EBR scheme to support Extended Boot Records has been added, the BSD scheme now support
bootcode, and bugs in the PC98 and VTOC8 schemes have been fixed.</p>

<p>An issue in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gvinum&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gvinum</span>(8)</span></a> with
access permissions to underlying disks used by a gvinum plex has been fixed. If the plex
is a raid5 plex and is being written to, parity data might have to be read from the
underlying disks, requiring them to be opened for reading as well as writing.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptmv&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptmv</span>(4)</span></a> driver
has been updated to version 1.16 from the vendor.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmc&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmc</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmcsd&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmcsd</span>(4)</span></a> drivers
now support MMC and SDHC cards, high speed timing, wide bus, and multiblock
transfers.</p>

<p>[sparc64] The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mpt&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mpt</span>(4)</span></a> driver is
now in the <tt class="FILENAME">GENERIC</tt> kernel.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
has been added. This supports PCI devices with class 8 and subclass 5 according to the SD
Host Controller Specification.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
now supports kernel dumping and a sysctl variable <code
class="VARNAME">hw.sdhci.debug</code> for debug level.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
now supports 64-bit DMA.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmc&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmc</span>(4)</span></a> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mmcsd&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mmcsd</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdhci&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdhci</span>(4)</span></a> driver
are now included as kernel modules.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>The semantics of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acl&sektion=3&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acl</span>(3)</span></a> extended
access control lists has been changed as follows:</p>

<ul>
<li>
<p>The inode modification time (mtime) is not updated when extended attributes are added,
modified, or removed.</p>
</li>

<li>
<p>The inode access time (atime) is not updated when extended attributes are queried.</p>
</li>
</ul>

<p>The FreeBSD NFS file system now supports a sysctl variable <code
class="VARNAME">vfs.nfs.prime_access_cache</code> to determine whether or not <code
class="FUNCTION">nfs_getattr()</code> will use an ACCESS RPC to prime the access cache
instead of a simple GETATTR RPC. This is because on many NFS servers an ACCESS RPC is
much more expensive to service than a GETATTR RPC for files in an NFSv3 mount. The sysctl
variable is enabled by default to maintain the previous behavior.</p>

<p>The FreeBSD UDF file system now supports a fifo.</p>

<p>The shared vnode locking for pathname lookups in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=VFS&sektion=9&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">VFS</span>(9)</span></a> subsystem
has been improved. This is disabled by default. Setting a sysctl variable <code
class="VARNAME">vfs.lookup_shared</code> to <tt class="LITERAL">1</tt> enables it for
better performance. Note that the <tt class="LITERAL">LOOKUP_SHARED</tt> kernel option
equivalent to the sysctl variable has been removed.</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atacontrol&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atacontrol</span>(8)</span></a>
utility, which prevents it from working when <tt class="FILENAME">/usr</tt> is not
mounted or invoked from <tt class="FILENAME">/rescue</tt>, has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=btpand&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">btpand</span>(8)</span></a> daemon
from NetBSD has been added. This daemon provides support for Bluetooth Network Access
Point (NAP), Group Ad-hoc Network (GN) and Personal Area Network User (PANU)
profiles.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ncal&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ncal</span>(1)</span></a> utility
now supports multibyte characters.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=config&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">config</span>(8)</span></a>
utility now supports multiple <code class="VARNAME">makeoption</code> lines.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=csup&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">csup</span>(1)</span></a> utility
now supports CVSMode to fetch a complete CVS repository. Note that the rsync transfer
mode is currently disabled.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dirname&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dirname</span>(1)</span></a>
utility now accepts multiple arguments in the same way that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=basename&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">basename</span>(1)</span></a>
does.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports an <code class="OPTION">-l</code> flag. When specified, the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility counts
a file with multiple hard links as multiple different files.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports an <code class="OPTION">-A</code> flag to display the apparent size instead of
the disk usage. This can be helpful when operating on compressed volumes or sparse
files.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=du&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">du</span>(1)</span></a> utility now
supports a <code class="OPTION">-B <tt class="REPLACEABLE"><i>blocksize</i></tt></code>
option to calculate block counts in blocks of <tt
class="REPLACEABLE"><i>blocksize</i></tt> bytes. This is different from the <code
class="OPTION">-k</code> or <code class="OPTION">-m</code> options or setting <code
class="VARNAME">BLOCKSIZE</code> and gives an estimate of how much space the examined
file hierarchy would require on a file system with the given <tt
class="REPLACEABLE"><i>blocksize</i></tt>. Unless in <code class="OPTION">-A</code> mode,
<tt class="REPLACEABLE"><i>blocksize</i></tt> is rounded up to the next multiple of
512.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dumpfs&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dumpfs</span>(8)</span></a>
utility now supports an <code class="OPTION">-f</code> flag, which causes it to list all
free fragments in the file system by fragment (block) number. This new mode does the
necessary arithmetic to generate absolute fragment numbers rather than the cg-relative
numbers printed in the default mode.</p>

<p>If <code class="OPTION">-f</code> is passed once, contiguous fragment ranges are
collapsed into an X-Y format as free block lists are currently printed in regular dumpfs
output. If specified twice, all block numbers are printed individually, allowing both
compact and more script-friendly representation.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a> utility
now supports an <code class="OPTION">-i</code> flag which supports the If-Modified-Since
HTTP 1.1 request. If specified it will cause the file to be downloaded only if it is more
recent than the mtime of the local file. Also, <b class="APPLICATION">libfetch</b> now
accepts the mtime in the url structure and a flag to indicate when this behavior is
desired.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> utility
now supports a <code class="OPTION">-C</code> flag for <tt class="LITERAL">check
clean</tt> mode. This checks if the file system was dismounted cleanly first and then
skip file system checks if true. Otherwise it does full checks.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> utility
now supports a <code class="OPTION">-D</code> flag for damaged recovery mode, which will
enable certain aggressive operations that can make <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> to
survive with file systems that has very serious data damage. This is a useful last resort
when on disk data damage is very serious and causes <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> to
crash.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>
function now supports SCTP.</p>

<p>A bug was fixed in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> utility
which displays extra messages for a NAT rule even when a <code class="OPTION">-q</code>
flag is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> utility now
supports a <code class="OPTION">-w</code> flag to check if the source file actually
exists. When the flag is specified and the file does not exist, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ln&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ln</span>(1)</span></a> will issue a
warning message.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports a <code class="OPTION">-p</code> flag to print the input graph only, without
executing any commands. The output is the same as <code class="OPTION">-d g1</code>. When
combined with <code class="OPTION">-f /dev/null</code>, only the built-in rules of make
are displayed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports a <code class="OPTION">-Q</code> flag to cause file banners not to be
generated in addition to the same effect of a <code class="OPTION">-q</code> flag when a
<code class="OPTION">-j</code> option is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports the <code class="VARNAME">.MAKE.JOB.PREFIX</code> variable. If <code
class="OPTION">-j</code> and <code class="OPTION">-v</code> are specified, its output for
each target is prefixed with a token <tt class="LITERAL">--- <tt
class="REPLACEABLE"><i>target</i></tt> ---</tt> the first part of which can be controlled
via the variable.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> utility
now supports <code class="VARNAME">.MAKE.PID</code> and <code
class="VARNAME">.MAKE.PPID</code> variable. These are set to process ID of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> process
and its parent process respectively.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=makefs&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">makefs</span>(8)</span></a>
utility to create a file system image from a directory tree has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
utility now supports an <code class="OPTION">-F</code> option to automatically install
files that differ only in their version control ID strings.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> utility
now supports an <code class="OPTION">-o mountprog=<tt
class="REPLACEABLE"><i>/somewhere/mount_xxx</i></tt></code> option to force it to use the
specified program to mount the file system instead of calling <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nmount&sektion=2&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nmount</span>(2)</span></a>
directly. This is useful when you want to use third party programs such as FUSE, for
example.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility now reports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unix&sektion=4&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unix</span>(4)</span></a> sockets'
listen queue statistics when an <code class="OPTION">-L</code> flag is specified.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility has been fixed. It crashed with the following options in the previous
versions:</p>

<pre class="SCREEN">
<samp class="PROMPT">%</samp> netstat -m -N foo
</pre>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netstat&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netstat</span>(1)</span></a>
utility has been fixed. The <code class="OPTION">-ss</code> option now works in the icmp6
section as expected.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pciconf&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pciconf</span>(8)</span></a>
utility now supports a <code class="OPTION">-b</code> flag, which lists any base address
registers (BAR) that are assigned resources for each device.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=powerd&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">powerd</span>(8)</span></a>
program has been improved. Changes include reasonable CPU load estimation on SMP systems
and a new mode named as <tt class="LITERAL">hiadaptive</tt> for AC-powered systems. The
<tt class="LITERAL">hiadaptive</tt> mode raises the CPU frequency twice as fast as <tt
class="LITERAL">adaptive</tt>, it drops the CPU frequency 4 times slower, prefers twice
lower CPU load and has an additional delay before leaving the highest frequency after the
period of maximum load.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=stat&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">stat</span>(1)</span></a> utility
now displays an octal representation of suid, sgid and sticky bits when the <code
class="OPTION">-x</code> flag is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strndup&sektion=3&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strndup</span>(3)</span></a>
function has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wc&sektion=1&manpath=FreeBSD+7.2-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">wc</span>(1)</span></a> utility now
supports an <code class="OPTION">-L</code> flag to output the number of characters in the
longest input line.</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpc.yppasswdd&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpc.yppasswdd</span>(8)</span></a>
program, which causes it to leave a zombie process when a password or default shell is
changed, has been fixed.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">ISC BIND</b> has been updated to version 9.4.3-P2.</p>

<p>The timezone database has been updated from the <b class="APPLICATION">tzdata2008h</b>
release to the <b class="APPLICATION">tzdata2009f</b> release.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_create</span>(1)</span></a>
utility, which prevents the <code class="OPTION">-n</code> flag from working has been
fixed.</p>

<p>The FreeBSD Ports Collection now supports multiple <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> jobs in
some supported ports. This is automatically enabled when a port is marked as <code
class="VARNAME">MAKE_JOBS_SAFE</code> and improves CPU utilization at the build stage by
passing an option <code class="OPTION">-j<tt class="REPLACEABLE"><i>X</i></tt></code> to
the top level <tt class="FILENAME">Makefile</tt> from the vendor. The number <tt
class="REPLACEABLE"><i>X</i></tt> is set to the number of CPUs by default, and can be set
by users via a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=make&sektion=1&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">make</span>(1)</span></a> variable
<code class="VARNAME">MAKE_JOBS_NUMBER</code>. For more details, see <tt
class="FILENAME">ports/Mk/bsd.port.mk</tt>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) has been updated from 2.22 to 2.26.</p>

<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment has
been updated from 3.5.10 (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde3/pkg-descr"><tt
class="FILENAME">x11/kde3</tt></a>) to 4.2.2 (<a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/kde4/pkg-descr"><tt
class="FILENAME">x11/kde4</tt></a>).</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>[amd64, i386] Beginning with FreeBSD 6.2-RELEASE, binary upgrades between RELEASE
versions (and snapshots of the various security branches) are supported using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility. The binary upgrade
procedure will update unmodified userland utilities, as well as unmodified GENERIC or SMP
kernels distributed as a part of an official FreeBSD release. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=freebsd-update&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">freebsd-update</span>(8)</span></a> utility requires that the host
being upgraded has Internet connectivity.</p>

<p>An older form of binary upgrade is supported through the <tt
class="COMMAND">Upgrade</tt> option from the main <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&sektion=8&manpath=FreeBSD+7.2-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
menu on CDROM distribution media. This type of binary upgrade may be useful on non-i386,
non-amd64 machines or on systems with no Internet connectivity.</p>

<p>Source-based upgrades (those based on recompiling the FreeBSD base system from source
code) from previous versions are supported, according to the instructions in <tt
class="FILENAME">/usr/src/UPDATING</tt>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


